<template>
  <q-layout view="lHh Lpr lFf" class="bg-grey-4">
    <q-header elevated class="bg-purple-3">
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          icon="menu"
          aria-label="Menu"
          @click="toggleLeftDrawer"
        />
      </q-toolbar>
    </q-header>

    <q-drawer v-model="leftDrawerOpen" show-if-above bordered>
      <q-list>
        <q-item-label class="text-weight-bold text-h5" header color="white">
          My Todo App
        </q-item-label>

        <EssentialLink
          v-for="link in essentialLinks"
          :key="link.title"
          v-bind="link"
        />
      </q-list>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { defineComponent, ref } from "vue";
import EssentialLink from "components/EssentialLink.vue";

const linksList = [
  {
    title: "My Task",
    caption: "List of unfinished tasks",
    icon: "task",
    route_name: "my-task",
  },
  {
    title: "Finished Task",
    caption: "List of unfinished tasks",
    icon: "check_circle_outline",
    route_name: "finished-task",
  },
  {
    title: "Deleted Task",
    caption: "List of unfinished tasks",
    icon: "delete_outline",
    route_name: "deleted-task",
  },
];

export default defineComponent({
  name: "MainLayout",

  components: {
    EssentialLink,
  },

  setup() {
    const leftDrawerOpen = ref(false);

    return {
      essentialLinks: linksList,
      leftDrawerOpen,
      toggleLeftDrawer() {
        leftDrawerOpen.value = !leftDrawerOpen.value;
      },
    };
  },
});
</script>
